<?php

namespace App\Models;

use App\Entities\TipoProdutoServico\TipoProdutoServico;

// use const False\MyClass\true;
class TipoProdutoServicoModel extends ModelEntity {
	protected $table = 'tipo_produto_servico';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [ 
			'descricao',
			'criado_por',
			'data_criacao',
			'hora_criacao'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = false;

	public function registerTipoProdutoServico(TipoProdutoServico $tipoExtorno): void {

		$id_new_tipo_extorno = $this->insert( $tipoExtorno->toArray( true ) );
		$tipoExtorno->setId( $id_new_tipo_extorno );

	}

	public function updateTipoProdutoServicoByID(int $id_tipo_extorno, TipoProdutoServico $tipo_extorno): bool {

		$data = $tipo_extorno->toArray( true );
		$binds = [ 
				'id_tipo_produto_servico' => $id_tipo_extorno
		];
		$sets = $this->generateUpdateSets( $data, $binds );
		$sql = "UPDATE tipo_produto_servico $sets WHERE tipo_produto_servico.id = :id_tipo_extorno:";
		$query = $this->db->query( $sql, $binds );
		return $query->connID->affected_rows === 1;

	}

}
